
<refentry id="FLknob">
<indexterm id="IndexFLknob"><primary>FLknob</primary></indexterm>
  <refentryinfo><title>FLTK:Valuators</title></refentryinfo>
  <refmeta>
    <refentrytitle>FLknob</refentrytitle>
  </refmeta>



  <refnamediv>
    <refname>FLknob</refname>
    <refpurpose>
      A FLTK widget opcode that creates a knob.
          </refpurpose>
  </refnamediv>
  
  <refsect1>
    <title>Description</title>
    <para>
      A FLTK widget opcode that creates a knob.
    </para>
  </refsect1>

  <refsect1>
    <title>Syntax</title>
    <synopsis>kout, ihandle <command>FLknob</command> &quot;label&quot;, imin, imax, iexp, itype, idisp, iwidth, \
      ix, iy [, icursorsize]</synopsis>
  </refsect1>

  <refsect1>
    <title>Initialization</title>
    <para>
      <emphasis>ihandle</emphasis> -- a handle value (an integer number) that unequivocally references a corresponding widget. This is used by other opcodes that modify a widget's properties (see <link linkend="ControlFltkAppearance"><citetitle>Modifying FLTK Widget Appearance</citetitle></link>). It is automatically utput by <emphasis>FLknob</emphasis> and must not be set by the user label. (The user label is a double-quoted string containing some user-provided text placed near the widget.)
    </para>
    <para>
      <emphasis><quote>label</quote></emphasis> -- a double-quoted string containing some user-provided text, placed near the corresponding widget.
    </para>

    <para>
      <emphasis>imin</emphasis> -- minimum value of output range.
    </para>

    <para>
      <emphasis>imax</emphasis> -- maximum value of output range.
    </para>

    <para>
      <emphasis>iexp</emphasis> -- an integer number denoting the behaviour of valuator: 
      <itemizedlist>
        <listitem><para>0 = valuator output is linear</para></listitem>
        <listitem><para>-1 = valuator output is exponential</para></listitem>
      </itemizedlist>
    </para>

    <para>
      All other positive numbers for <emphasis>iexp</emphasis> indicate the number of an existing table that is used for indexing. Linear interpolation is provided in table indexing. A negative table number suppresses interpolation. 
    </para>

    <warning>
      <title>IMPORTANT!</title>
      <para>
        Notice that the tables used by valuators must be created with the <link linkend="ftgen"><citetitle>ftgen</citetitle></link> opcode and placed in the orchestra before the corresponding valuator. They can not placed
in the score. In fact, tables placed in the score are created later than the initialization of the opcodes placed in the header section of the orchestra.
      </para>
    </warning>

    <para>
      <emphasis>itype</emphasis> -- an integer number denoting the appearance of the valuator.
    </para>

    <para>
      The <emphasis>itype</emphasis> argument can be set to the following values:

      <itemizedlist>
        <listitem><para>1 - a 3-D knob</para></listitem>
        <listitem><para>2 - a pie-like knob</para></listitem>
        <listitem><para>3 - a clock-like knob</para></listitem>
        <listitem><para>4 - a flat knob</para></listitem>
      </itemizedlist>

      <mediaobject>
        <imageobject>
          <imagedata fileref="images/flknob_3d.png" format="PNG"/>
        </imageobject>

        <textobject>
          <phrase>A 3-D knob.</phrase>
        </textobject>

        <caption>
          <para>A 3-D knob.</para>
        </caption>
      </mediaobject>

      <mediaobject>
        <imageobject>
          <imagedata fileref="images/flknob_pie.png" format="PNG"/>
        </imageobject>

        <textobject>
          <phrase>A pie knob.</phrase>
        </textobject>

        <caption>
          <para>A pie knob.</para>
        </caption>
      </mediaobject>

      <mediaobject>
        <imageobject>
          <imagedata fileref="images/flknob_clock.png" format="PNG"/>
        </imageobject>

        <textobject>
          <phrase>A clock knob.</phrase>
        </textobject>

        <caption>
          <para>A clock knob.</para>
        </caption>
      </mediaobject>

      <mediaobject>
        <imageobject>
          <imagedata fileref="images/flknob_flat.png" format="PNG"/>
        </imageobject>

        <textobject>
          <phrase>A flat knob.</phrase>
        </textobject>

        <caption>
          <para>A flat knob.</para>
        </caption>
      </mediaobject>
    </para>

    <para>
      <emphasis>idisp</emphasis> -- a handle value that was output
      from a previous instance of the <link
      linkend="FLvalue"><citetitle>FLvalue</citetitle></link> opcode
      to display the current value of the current valuator in the
      <emphasis>FLvalue</emphasis> widget itself. If the user does not want to use this feature that displays current values, it must be set to a negative number by the user.
    </para>

    <para>
      <emphasis>iwidth</emphasis> -- width of widget.
    </para>

    <para>
      <emphasis>iheight</emphasis> -- height of widget.
    </para>

    <para>
      <emphasis>ix</emphasis> -- horizontal position of upper left corner of the valuator, relative to the upper left corner of corresponding window (expressed in pixels).
    </para>

    <para>
      <emphasis>iy</emphasis> -- vertical position of upper left corner of the valuator, relative to the upper left corner of corresponding window (expressed in pixels).
    </para>

    <para>
      <emphasis>icursorsize</emphasis> (optional) -- If <emphasis>FLknob</emphasis>'s <emphasis>itype</emphasis> is set to 1 (3D knob), this parameter controls the size of knob cursor.
    </para>
  </refsect1>

  <refsect1>
    <title>Performance</title>
    <para>
      <emphasis>kout</emphasis> -- output value
    </para>

    <para>
      <emphasis>FLknob</emphasis> puts a knob in the corresponding container.
    </para>
  </refsect1>

  <refsect1>
    <title>Examples</title>
    <para>
      Here is an example of the FLknob opcode. It uses the file <ulink url="examples/FLknob.csd"><citetitle>FLknob.csd</citetitle></ulink>.

      <example>
        <title>Example of the FLknob opcode.</title>

        <para>See the sections <link linkend="UsingRealTime"><citetitle>Real-time Audio</citetitle></link> and <link linkend="CommandFlags"><citetitle>Command Line Flags</citetitle></link> for more information on using command line flags.</para>
          <xi:include href="examples-xml/FLknob.csd.xml" xmlns:xi="http://www.w3.org/2001/XInclude"/>
      </example>
    </para>
    <para>
      Here is another example of the FLknob opcode, showing the different styles of knobs and the usage of FLvalue to display a knob's value. It uses the file <ulink url="examples/FLknob-2.csd"><citetitle>FLknob-2.csd</citetitle></ulink>.

      <example>
        <title>More complex example of the FLknob opcode.</title>

          <xi:include href="examples-xml/FLknob-2.csd.xml" xmlns:xi="http://www.w3.org/2001/XInclude"/>
      </example>
    </para>
  </refsect1>

  <refsect1>
    <title>See Also</title>
    <para>
      <link linkend="FLcount"><citetitle>FLcount</citetitle></link>,
      <link linkend="FLjoy"><citetitle>FLjoy</citetitle></link>,
      <link linkend="FLroller"><citetitle>FLroller</citetitle></link>,
      <link linkend="FLslider"><citetitle>FLslider</citetitle></link>,
      <link linkend="FLtext"><citetitle>FLtext</citetitle></link>
    </para>
  </refsect1>

  <refsect1>
    <title>Credits</title>
    <para>Author: &namegabriel;</para>
    <para>New in version 4.22</para>
    <para>Example written by Iain McCurdy, edited by &namekevin;.</para>
  </refsect1>
</refentry>
